---
title: extends
slug: Web/JavaScript/Reference/Classes/extends
tags:
  - Classes
  - ECMAScript 2015
  - JavaScript
  - Language feature
---
<div>{{jsSidebar("Classes")}}</div>

<p>The <strong><code>extends</code></strong> keyword is used in <a href="/en-US/docs/Web/JavaScript/Reference/Statements/class">class declarations</a> or <a href="/en-US/docs/Web/JavaScript/Reference/Operators/class">class expressions</a> to create a class that is a child of another class.</p>

<div>{{EmbedInteractiveExample("pages/js/classes-extends.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">class ChildClass extends ParentClass { ... }</pre>

<h2 id="Description">Description</h2>

<p>The <code>extends</code> keyword can be used to subclass custom classes as well as built-in objects.</p>

<p>The <code>.prototype</code> of the extension must be an {{jsxref("Object")}} or {{jsxref("null")}}.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_extends">Using extends</h3>

<p>The first example creates a class called <code>Square</code> from a class called <code>Polygon</code>. This example is extracted from this <a href="https://googlechrome.github.io/samples/classes-es6/index.html">live demo</a> <a href="https://github.com/GoogleChrome/samples/blob/gh-pages/classes-es6/index.html">(source)</a>.</p>

<pre class="brush: js notranslate">class Square extends Polygon {
  constructor(length) {
    // Here, it calls the parent class' constructor with lengths
    // provided for the Polygon's width and height
    super(length, length);
    // Note: In derived classes, super() must be called before you
    // can use 'this'. Leaving this out will cause a reference error.
    this.name = 'Square';
  }

  get area() {
    return this.height * this.width;
  }
}</pre>

<h3 id="Using_extends_with_built-in_objects">Using extends with built-in objects</h3>

<p>This example extends the built-in {{jsxref("Date")}} object. This example is extracted from this <a href="https://googlechrome.github.io/samples/classes-es6/index.html">live demo</a> <a href="https://github.com/GoogleChrome/samples/blob/gh-pages/classes-es6/index.html">(source)</a>.</p>

<pre class="brush: js notranslate">class myDate extends Date {

  getFormattedDate() {
    var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
    return this.getDate() + '-' + months[this.getMonth()] + '-' + this.getFullYear();
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-class-definitions', 'extends')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.classes.extends")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Classes">Classes</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Classes/constructor">constructor</a></li>
 <li><a href="/en-US/docs/Web/JavaScript/Reference/Operators/super">super</a></li>
 <li><a href="https://medium.com/beginners-guide-to-mobile-web-development/super-and-extends-in-javascript-es6-understanding-the-tough-parts-6120372d3420">Anurag Majumdar - Super &amp; Extends in JavaScript</a></li>
</ul>
